
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct segmenttree {
    int s, edges;
    vector<pair<ll, ll>> segtree;

    void init(vector<long long>& Heap) {
        edges = Heap.size()-2;
        s = 1;
        while(s < edges)
            s *= 2;

        segtree.resize(2*s, {0, 0});

        for(int i=0; i<edges; i++) {
            segtree[s+i].second = Heap[i+2] - Heap[(i+2)/2];
            segtree[s+i].first = segtree[s+i].second;
        }

        for(int i=s-1; i>0; i--)
            segtree[i].first =
                min(segtree[2*i].first, segtree[2*i+1].first) + segtree[i].second;
    }

    void isHeap() {
        if(segtree[1].first >= 0) cout << "TAK\n";
        else cout << "NIE\n";
    }

    void updateSegment(int v, int l, int r, int x, int y, long long z) {
        if(x > y || r < x || y < l)
            return;

        if(x <= l && r <= y) {
            segtree[v].second += z;
            segtree[v].first += z;
            return;
        }

        updateSegment(2*v, l, (l+r)/2, x, y, z);
        updateSegment(2*v+1, (l+r)/2+1, r, x, y, z);
        segtree[v].first =
            min(segtree[2*v].first, segtree[2*v+1].first) + segtree[v].second;
    }

    void update(int x, int y, long long z) {
        updateSegment(1, 0, s-1, max(x-2, 0), min(y-2, edges-1), z);
        updateSegment(1, 0, s-1, max(2*x-2, 0), min(2*y-1, edges-1), -z);
    }
};

int main() {
    ios_base::sync_with_stdio(0);

    int n; cin >> n;
    vector<ll> Heap(n+1);
    for(int i=1; i<=n; i++)
        cin >> Heap[i];

    segmenttree tree;
    tree.init(Heap);

    tree.isHeap();
    int q; cin >> q;

    while(q--) {
        int x, y; ll z;
        cin >> x >> y >> z;

        tree.update(x, y, z);
        tree.isHeap();
    }

    return 0;
}
